part of '../language_helper.dart';

/// LanguageCodes(code, name in English, name in native)
///   - [code]: language code
///   - [name]: name in English
///   - [nativeName]: name in native
///
/// @Source https://stackoverflow.com/questions/3217492/list-of-language-codes-in-yaml-or-json
enum LanguageCodes {
  ab("ab", "Abkhaz", "аҧсуа"),
  aa("aa", "Afar", "Afaraf"),
  af("af", "Afrikaans", "Afrikaans"),
  ak("ak", "Akan", "Akan"),
  sq("sq", "Albanian", "Shqip"),
  am("am", "Amharic", "አማርኛ"),
  ar("ar", "Arabic", "العربية"),
  an("an", "Aragonese", "Aragonés"),
  hy("hy", "Armenian", "Հայերեն"),
  as("as", "Assamese", "অসমীয়া"),
  av("av", "Avaric", "авар мацӀ, магӀарул мацӀ"),
  ae("ae", "Avestan", "avesta"),
  ay("ay", "Aymara", "aymar aru"),
  az("az", "Azerbaijani", "azərbaycan dili"),
  bm("bm", "Bambara", "bamanankan"),
  ba("ba", "Bashkir", "башҡорт теле"),
  eu("eu", "Basque", "euskara, euskera"),
  be("be", "Belarusian", "Беларуская"),
  bn("bn", "Bengali", "বাংলা"),
  bh("bh", "Bihari", "भोजपुरी"),
  bi("bi", "Bislama", "Bislama"),
  bs("bs", "Bosnian", "bosanski jezik"),
  br("br", "Breton", "brezhoneg"),
  bg("bg", "Bulgarian", "български език"),
  my("my", "Burmese", "ဗမာစာ"),
  ca("ca", "Catalan; Valencian", "Català"),
  ch("ch", "Chamorro", "Chamoru"),
  ce("ce", "Chechen", "нохчийн мотт"),
  ny("ny", "Chichewa; Chewa; Nyanja", "chiCheŵa, chinyanja"),
  zh("zh", "Chinese", "中文 (Zhōngwén), 汉语, 漢語"),
  cv("cv", "Chuvash", "чӑваш чӗлхи"),
  kw("kw", "Cornish", "Kernewek"),
  co("co", "Corsican", "corsu, lingua corsa"),
  cr("cr", "Cree", "ᓀᐦᐃᔭᐍᐏᐣ"),
  hr("hr", "Croatian", "hrvatski"),
  cs("cs", "Czech", "česky, čeština"),
  da("da", "Danish", "dansk"),
  dv("dv", "Divehi; Dhivehi; Maldivian;", "ދިވެހި"),
  nl("nl", "Dutch", "Nederlands, Vlaams"),
  en("en", "English", "English"),
  eo("eo", "Esperanto", "Esperanto"),
  et("et", "Estonian", "eesti, eesti keel"),
  ee("ee", "Ewe", "Eʋegbe"),
  fo("fo", "Faroese", "føroyskt"),
  fj("fj", "Fijian", "vosa Vakaviti"),
  fi("fi", "Finnish", "suomi, suomen kieli"),
  fr("fr", "French", "français, langue française"),
  ff("ff", "Fula; Fulah; Pulaar; Pular", "Fulfulde, Pulaar, Pular"),
  gl("gl", "Galician", "Galego"),
  ka("ka", "Georgian", "ქართული"),
  de("de", "German", "Deutsch"),
  el("el", "Greek, Modern", "Ελληνικά"),
  gn("gn", "Guaraní", "Avañeẽ"),
  gu("gu", "Gujarati", "ગુજરાતી"),
  ht("ht", "Haitian; Haitian Creole", "Kreyòl ayisyen"),
  ha("ha", "Hausa", "Hausa, هَوُسَ"),
  he("he", "Hebrew (modern)", "עברית"),
  hz("hz", "Herero", "Otjiherero"),
  hi("hi", "Hindi", "हिन्दी, हिंदी"),
  ho("ho", "Hiri Motu", "Hiri Motu"),
  hu("hu", "Hungarian", "Magyar"),
  ia("ia", "Interlingua", "Interlingua"),
  id("id", "Indonesian", "Bahasa Indonesia"),
  ie("ie", "Interlingue",
      "Originally called Occidental; then Interlingue after WWII"),
  ga("ga", "Irish", "Gaeilge"),
  ig("ig", "Igbo", "Asụsụ Igbo"),
  ik("ik", "Inupiaq", "Iñupiaq, Iñupiatun"),
  io("io", "Ido", "Ido"),

  /// Add _ to avoid default keyword `is` of Dart
  is_("is", "Icelandic", "Íslenska"),
  it("it", "Italian", "Italiano"),
  iu("iu", "Inuktitut", "ᐃᓄᒃᑎᑐᑦ"),
  ja("ja", "Japanese", "日本語 (にほんご／にっぽんご)"),
  jv("jv", "Javanese", "basa Jawa"),
  kl("kl", "Kalaallisut, Greenlandic", "kalaallisut, kalaallit oqaasii"),
  kn("kn", "Kannada", "ಕನ್ನಡ"),
  kr("kr", "Kanuri", "Kanuri"),
  ks("ks", "Kashmiri", "कश्मीरी, كشميري‎"),
  kk("kk", "Kazakh", "Қазақ тілі"),
  km("km", "Khmer", "ភាសាខ្មែរ"),
  ki("ki", "Kikuyu, Gikuyu", "Gĩkũyũ"),
  rw("rw", "Kinyarwanda", "Ikinyarwanda"),
  ky("ky", "Kirghiz, Kyrgyz", "кыргыз тили"),
  kv("kv", "Komi", "коми кыв"),
  kg("kg", "Kongo", "KiKongo"),
  ko("ko", "Korean", "한국어 (韓國語), 조선말 (朝鮮語)"),
  ku("ku", "Kurdish", "Kurdî, كوردی‎"),
  kj("kj", "Kwanyama, Kuanyama", "Kuanyama"),
  la("la", "Latin", "latine, lingua latina"),
  lb("lb", "Luxembourgish, Letzeburgesch", "Lëtzebuergesch"),
  lg("lg", "Luganda", "Luganda"),
  li("li", "Limburgish, Limburgan, Limburger", "Limburgs"),
  ln("ln", "Lingala", "Lingála"),
  lo("lo", "Lao", "ພາສາລາວ"),
  lt("lt", "Lithuanian", "lietuvių kalba"),
  lu("lu", "Luba-Katanga", ""),
  lv("lv", "Latvian", "latviešu valoda"),
  gv("gv", "Manx", "Gaelg, Gailck"),
  mk("mk", "Macedonian", "македонски јазик"),
  mg("mg", "Malagasy", "Malagasy fiteny"),
  ms("ms", "Malay", "bahasa Melayu, بهاس ملايو‎"),
  ml("ml", "Malayalam", "മലയാളം"),
  mt("mt", "Maltese", "Malti"),
  mi("mi", "Māori", "te reo Māori"),
  mr("mr", "Marathi (Marāṭhī)", "मराठी"),
  mh("mh", "Marshallese", "Kajin M̧ajeļ"),
  mn("mn", "Mongolian", "монгол"),
  na("na", "Nauru", "Ekakairũ Naoero"),
  nv("nv", "Navajo, Navaho", "Diné bizaad, Dinékʼehǰí"),
  nb("nb", "Norwegian Bokmål", "Norsk bokmål"),
  nd("nd", "North Ndebele", "isiNdebele"),
  ne("ne", "Nepali", "नेपाली"),
  ng("ng", "Ndonga", "Owambo"),
  nn("nn", "Norwegian Nynorsk", "Norsk nynorsk"),
  no("no", "Norwegian", "Norsk"),
  ii("ii", "Nuosu", "ꆈꌠ꒿ Nuosuhxop"),
  nr("nr", "South Ndebele", "isiNdebele"),
  oc("oc", "Occitan", "Occitan"),
  oj("oj", "Ojibwe, Ojibwa", "ᐊᓂᔑᓈᐯᒧᐎᓐ"),
  cu(
      "cu",
      "Old Church Slavonic, Church Slavic, Church Slavonic, Old Bulgarian, Old Slavonic",
      "ѩзыкъ словѣньскъ"),
  om("om", "Oromo", "Afaan Oromoo"),
  or("or", "Oriya", "ଓଡ଼ିଆ"),
  os("os", "Ossetian, Ossetic", "ирон æвзаг"),
  pa("pa", "Panjabi, Punjabi", "ਪੰਜਾਬੀ, پنجابی‎"),
  pi("pi", "Pāli", "पाऴि"),
  fa("fa", "Persian", "فارسی"),
  pl("pl", "Polish", "polski"),
  ps("ps", "Pashto, Pushto", "پښتو"),
  pt("pt", "Portuguese", "Português"),
  qu("qu", "Quechua", "Runa Simi, Kichwa"),
  rm("rm", "Romansh", "rumantsch grischun"),
  rn("rn", "Kirundi", "kiRundi"),
  ro("ro", "Romanian, Moldavian, Moldovan", "română"),
  ru("ru", "Russian", "русский язык"),
  sa("sa", "Sanskrit (Saṁskṛta)", "संस्कृतम्"),
  sc("sc", "Sardinian", "sardu"),
  sd("sd", "Sindhi", "सिन्धी, سنڌي، سندھی‎"),
  se("se", "Northern Sami", "Davvisámegiella"),
  sm("sm", "Samoan", "gagana faa Samoa"),
  sg("sg", "Sango", "yângâ tî sängö"),
  sr("sr", "Serbian", "српски језик"),
  gd("gd", "Scottish Gaelic; Gaelic", "Gàidhlig"),
  sn("sn", "Shona", "chiShona"),
  si("si", "Sinhala, Sinhalese", "සිංහල"),
  sk("sk", "Slovak", "slovenčina"),
  sl("sl", "Slovene", "slovenščina"),
  so("so", "Somali", "Soomaaliga, af Soomaali"),
  st("st", "Southern Sotho", "Sesotho"),
  es("es", "Spanish; Castilian", "español, castellano"),
  su("su", "Sundanese", "Basa Sunda"),
  sw("sw", "Swahili", "Kiswahili"),
  ss("ss", "Swati", "SiSwati"),
  sv("sv", "Swedish", "svenska"),
  ta("ta", "Tamil", "தமிழ்"),
  te("te", "Telugu", "తెలుగు"),
  tg("tg", "Tajik", "тоҷикӣ, toğikī, تاجیکی‎"),
  th("th", "Thai", "ไทย"),
  ti("ti", "Tigrinya", "ትግርኛ"),
  bo("bo", "Tibetan Standard, Tibetan, Central", "བོད་ཡིག"),
  tk("tk", "Turkmen", "Türkmen, Түркмен"),
  tl("tl", "Tagalog", "Wikang Tagalog, ᜏᜒᜃᜅ᜔ ᜆᜄᜎᜓᜄ᜔"),
  tn("tn", "Tswana", "Setswana"),
  to("to", "Tonga (Tonga Islands)", "faka Tonga"),
  tr("tr", "Turkish", "Türkçe"),
  ts("ts", "Tsonga", "Xitsonga"),
  tt("tt", "Tatar", "татарча, tatarça, تاتارچا‎"),
  tw("tw", "Twi", "Twi"),
  ty("ty", "Tahitian", "Reo Tahiti"),
  ug("ug", "Uighur, Uyghur", "Uyƣurqə, ئۇيغۇرچە‎"),
  uk("uk", "Ukrainian", "українська"),
  ur("ur", "Urdu", "اردو"),
  uz("uz", "Uzbek", "zbek, Ўзбек, أۇزبېك‎"),
  ve("ve", "Venda", "Tshivenḓa"),
  vi("vi", "Vietnamese", "Tiếng Việt"),
  vo("vo", "Volapük", "Volapük"),
  wa("wa", "Walloon", "Walon"),
  cy("cy", "Welsh", "Cymraeg"),
  wo("wo", "Wolof", "Wollof"),
  fy("fy", "Western Frisian", "Frysk"),
  xh("xh", "Xhosa", "isiXhosa"),
  yi("yi", "Yiddish", "ייִדיש"),
  yo("yo", "Yoruba", "Yorùbá"),
  za("za", "Zhuang, Chuang", "Saɯ cueŋƅ, Saw cuengh");

  /// Language code
  final String code;

  /// Language name in English
  final String name;

  /// Language name in native
  final String nativeName;

  /// Get current code as Locale
  Locale get locale => Locale(code);

  /// Get [LanguageCodes] from string [code]
  static LanguageCodes fromCode(String code) =>
      LanguageCodes.values.singleWhere((element) => element.code == code);

  /// Get [LanguageCodes] from [Locale]
  static LanguageCodes fromLocale(Locale locale) =>
      fromCode(locale.languageCode);

  /// LanguageCodes
  const LanguageCodes(this.code, this.name, this.nativeName);
}
